;NSIS Modern User Interface version 1.70
;UKW Tools install script
;Written by Jonathan Naylor

;--------------------------------
;Include Modern UI

  !include "MUI.nsh"

;--------------------------------
;Configuration

  ;General
  Name "UKW Tools 0.3.5"
  OutFile "UKWTools.exe"

  ;Folder selection page
  InstallDir "$PROGRAMFILES\UKW Tools"
  
  Var MAP_QTH_DIR
  Var DATA_DIR
  Var SRTM_DIR
  Var GLOBE_DIR
  Var GTOPO30_DIR

  ;Get install folder from registry if available
  InstallDirRegKey HKCU "Software\G4KLX\ukwtools\General" "inst_path"

;--------------------------------
;Interface Settings

  !define MUI_ABORTWARNING

;--------------------------------
;Pages

  !insertmacro MUI_PAGE_LICENSE "c:\msys\1.0\home\jsn\ukwtools-0.3.5\COPYING"
  !insertmacro MUI_PAGE_COMPONENTS
  !insertmacro MUI_PAGE_DIRECTORY

  Page custom MapQthDirPage
  !define MUI_DIRECTORYPAGE_VARIABLE $MAP_QTH_DIR
  !define MUI_DIRECTORYPAGE_TEXT_TOP "This folder holds the Map and Qth files, if selected earlier the example Map and Qth files will be copied into the following folder. To install in a different folder, click Browse and select another folder. Click Next to continue."
  !define MUI_DIRECTORYPAGE_TEXT_DESTINATION "Map and Qth Folder"
  !insertmacro MUI_PAGE_DIRECTORY

  Page custom DataDirPage
  !define MUI_DIRECTORYPAGE_VARIABLE $DATA_DIR
  !define MUI_DIRECTORYPAGE_TEXT_TOP "This folder holds the Sites and Towns files, if selected earlier the example Sites and Towns files will be copied into the following folder. To install in a different folder, click Browse and select another folder. Click Next to continue."
  !define MUI_DIRECTORYPAGE_TEXT_DESTINATION "Towns and Sites Folder"
  !insertmacro MUI_PAGE_DIRECTORY

  Page custom SrtmDirPage
  !define MUI_DIRECTORYPAGE_VARIABLE $SRTM_DIR
  !define MUI_DIRECTORYPAGE_TEXT_TOP "This folder holds the SRTM elevation data files for your area which you must download from the Internet or copy from elsewhere separately, into the following folder. To install in a different folder, click Browse and select another folder. Click Next to continue."
  !define MUI_DIRECTORYPAGE_TEXT_DESTINATION "SRTM Elevation Data Folder"
  !insertmacro MUI_PAGE_DIRECTORY

  Page custom GlobeDirPage
  !define MUI_DIRECTORYPAGE_VARIABLE $GLOBE_DIR
  !define MUI_DIRECTORYPAGE_TEXT_TOP "This folder holds the Global elevation data files for your area which you must download from the Internet or copy from elsewhere separately, into the following folder. To install in a different folder, click Browse and select another folder. Click Next to continue."
  !define MUI_DIRECTORYPAGE_TEXT_DESTINATION "Globe Elevation Data Folder"
  !insertmacro MUI_PAGE_DIRECTORY

  Page custom Gtopo30DirPage
  !define MUI_DIRECTORYPAGE_VARIABLE $GTOPO30_DIR
  !define MUI_DIRECTORYPAGE_TEXT_TOP "This folder holds the GTOPO30 elevation data files for your area which you must download from the Internet or copy from elsewhere separately, into the following folder. To install in a different folder, click Browse and select another folder. Click Next to continue."
  !define MUI_DIRECTORYPAGE_TEXT_DESTINATION "GTOPO30 Elevation Data Folder"
  !insertmacro MUI_PAGE_DIRECTORY

  !insertmacro MUI_PAGE_INSTFILES
  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES
  
;--------------------------------
;Languages
 
  !insertmacro MUI_LANGUAGE "English"

;--------------------------------
;Installer Sections

Section "UKW Tools Program Files" SecProgram

  CreateDirectory "$MAP_QTH_DIR"
  CreateDirectory "$DATA_DIR"
  CreateDirectory "$SRTM_DIR"
  CreateDirectory "$GLOBE_DIR"
  CreateDirectory "$GTOPO30_DIR"

  SetOutPath "$INSTDIR"
  
  File c:\msys\1.0\home\jsn\ukwtools-0.3.5\src\ukwtools.exe
  File c:\wxWindows-2.4.2\lib\wxmsw242.dll
  File /oname=Licence.txt c:\msys\1.0\home\jsn\ukwtools-0.3.5\COPYING
  File /oname=Changes.txt c:\msys\1.0\home\jsn\ukwtools-0.3.5\CHANGES
  File /oname=ToDo.txt    c:\msys\1.0\home\jsn\ukwtools-0.3.5\TODO
  File /oname=ReadMe.txt  c:\msys\1.0\home\jsn\ukwtools-0.3.5\README
  File ukwtools.ico

  ;Create start menu entry
  CreateDirectory "$SMPROGRAMS\UKW Tools"
  CreateShortCut "$SMPROGRAMS\UKW Tools\UKW Tools.lnk" "$INSTDIR\ukwtools.exe"  "" "$INSTDIR\ukwtools.ico"
  CreateShortCut "$SMPROGRAMS\UKW Tools\Licence.lnk"   "$INSTDIR\Licence.txt"
  CreateShortCut "$SMPROGRAMS\UKW Tools\ReadMe.lnk"    "$INSTDIR\ReadMe.txt"
  CreateShortCut "$SMPROGRAMS\UKW Tools\Changes.lnk"   "$INSTDIR\Changes.txt"
  CreateShortCut "$SMPROGRAMS\UKW Tools\ToDo.lnk"      "$INSTDIR\ToDo.txt"
  CreateShortCut "$SMPROGRAMS\UKW Tools\Uninstall.lnk" "$INSTDIR\Uninstall.exe"

  ;Create a Desktop short cut
  CreateShortCut "$DESKTOP\UKW Tools.lnk" "$INSTDIR\ukwtools.exe" "" "$INSTDIR\ukwtools.ico"

  ;Store install folder
  WriteRegStr HKCU "Software\G4KLX\ukwtools\General" "inst_path" $INSTDIR

  ;Store UKW Tools installation directories
  WriteRegStr HKCU "Software\G4KLX\ukwtools\General" "data_path"    $DATA_DIR
  WriteRegStr HKCU "Software\G4KLX\ukwtools\General" "globe_path"   $GLOBE_DIR
  WriteRegStr HKCU "Software\G4KLX\ukwtools\General" "gtopo30_path" $GTOPO30_DIR
  WriteRegStr HKCU "Software\G4KLX\ukwtools\General" "map_qth_path" $MAP_QTH_DIR
  WriteRegStr HKCU "Software\G4KLX\ukwtools\General" "srtm_path"    $SRTM_DIR

  ;Store Windows uninstall keys
  WriteRegStr   HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\UKW Tools" "DisplayName"      "UKW Tools"
  WriteRegStr   HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\UKW Tools" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\UKW Tools" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\UKW Tools" "NoRepair" 1

  ;Create uninstaller
  WriteUninstaller "$INSTDIR\Uninstall.exe"

SectionEnd

Section "Example .map Files" SecMap

  SetOutPath "$MAP_QTH_DIR"
  File c:\msys\1.0\home\jsn\ukwtools-0.3.5\data\*.map

SectionEnd

Section "Example .qth Files" SecPoints

  SetOutPath "$MAP_QTH_DIR"
  File c:\msys\1.0\home\jsn\ukwtools-0.3.5\data\*.qth
  
SectionEnd

Section "Example Sites Data" SecSites

  SetOutPath "$DATA_DIR"
  File c:\msys\1.0\home\jsn\ukwtools-0.3.5\data\sites.dat

SectionEnd

Section "Example Towns Data" SecTowns

  SetOutPath "$DATA_DIR"
  File c:\msys\1.0\home\jsn\ukwtools-0.3.5\data\towns.dat

SectionEnd

;--------------------------------
;Descriptions

  LangString DESC_Program ${LANG_ENGLISH} "This is the main UKW Tools program and support files, this is the minimum that you should install."
  LangString DESC_Map     ${LANG_ENGLISH} "The example .map data consists of the descriptions of maps in the UK and in mainland Europe."
  LangString DESC_Point   ${LANG_ENGLISH} "The example .qth data consists of many sites in the UK and a number of sites in mainland Europe. Most are denoted by either the name of the site or the callsign of the station located there."
  LangString DESC_Sites   ${LANG_ENGLISH} "This is an example sites.dat file which contains a number of well known portable sites in the UK and a very few in France."
  LangString DESC_Towns   ${LANG_ENGLISH} "This is an example towns.dat file which contains a small number of towns and villages in mid-Derbyshire."

  !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
    !insertmacro MUI_DESCRIPTION_TEXT ${SecProgram} $(DESC_Program)
    !insertmacro MUI_DESCRIPTION_TEXT ${SecMap}     $(DESC_Map)
    !insertmacro MUI_DESCRIPTION_TEXT ${SecPoints}  $(DESC_Point)
    !insertmacro MUI_DESCRIPTION_TEXT ${SecSites}   $(DESC_Sites)
    !insertmacro MUI_DESCRIPTION_TEXT ${SecTowns}   $(DESC_Towns)
  !insertmacro MUI_FUNCTION_DESCRIPTION_END

;--------------------------------
;Custom directory pages

  Function MapQthDirPage

    ReadRegStr $MAP_QTH_DIR HKCU "Software\G4KLX\ukwtools\General" "map_qth_path"

    StrCmp $MAP_QTH_DIR "" NoDir EndFunction

    NoDir:
        StrCpy $MAP_QTH_DIR "$INSTDIR\Data"

    EndFunction:

  FunctionEnd

  Function DataDirPage

    ReadRegStr $DATA_DIR HKCU "Software\G4KLX\ukwtools\General" "data_path"

    StrCmp $DATA_DIR "" NoDir EndFunction

    NoDir:
	StrCpy $DATA_DIR $MAP_QTH_DIR

    EndFunction:

  FunctionEnd

  Function SrtmDirPage

    ReadRegStr $SRTM_DIR HKCU "Software\G4KLX\ukwtools\General" "srtm_path"

    StrCmp $SRTM_DIR "" NoDir EndFunction

    NoDir:
	StrCpy $SRTM_DIR "$DATA_DIR\SRTM"

    EndFunction:

  FunctionEnd

  Function GlobeDirPage

    ReadRegStr $GLOBE_DIR HKCU "Software\G4KLX\ukwtools\General" "globe_path"

    StrCmp $GLOBE_DIR "" NoDir EndFunction

    NoDir:
	StrCpy $GLOBE_DIR "$DATA_DIR\Globe"

    EndFunction:

  FunctionEnd

  Function Gtopo30DirPage

    ReadRegStr $GTOPO30_DIR HKCU "Software\G4KLX\ukwtools\General" "gtopo30_path"

    StrCmp $GTOPO30_DIR "" NoDir EndFunction

    NoDir:
	StrCpy $GTOPO30_DIR "$DATA_DIR\GTOPO30"

    EndFunction:

  FunctionEnd

;--------------------------------
;Uninstaller Section

Section "Uninstall"

  Delete "$INSTDIR\ukwtools.exe"
  Delete "$INSTDIR\wxmsw242.dll"
  Delete "$INSTDIR\Uninstall.exe"
  Delete "$INSTDIR\Changes.txt"
  Delete "$INSTDIR\Licence.txt"
  Delete "$INSTDIR\ReadMe.txt"
  Delete "$INSTDIR\ToDo.txt"
  Delete "$INSTDIR\ukwtools.ico"

  Delete "$DESKTOP\UKW Tools.lnk"

  RMDir "$SRTM_DIR"
  RMDir "$GLOBE_DIR"
  RMDir "$GTOPO30_DIR"
  RMDir "$MAP_QTH_DIR"
  RMDir "$DATA_DIR"
  RMDir "$INSTDIR"

  Delete "$SMPROGRAMS\UKW Tools\*.*"
  RMDir  "$SMPROGRAMS\UKW Tools"

  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\UKW Tools"

  DeleteRegKey HKCU "Software\G4KLX\ukwtools"

SectionEnd
