/*
 *   Copyright (C) 2002,2003 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	DMap_H
#define	DMap_H

#include <wx/wx.h>
#include <wx/datetime.h>

#include "DEMCache.h"
#include "Palette.h"
#include "Point.h"

class C3DMap : public wxPanel, public wxTimer {

    public:
	C3DMap(wxWindow* parent, const CPoint& point, int mapSize);
	virtual ~C3DMap();

	virtual void onChar(wxKeyEvent& event);
	virtual void onPaint(const wxPaintEvent& event);
	virtual void onMouseClick(const wxMouseEvent& event);
	virtual void onMenuAngle(const wxCommandEvent& event);
	virtual void onMenuHeight(const wxCommandEvent& event);
	virtual void onMenuMapType(const wxCommandEvent& event);
	virtual void onMenuPalette(const wxCommandEvent& event);
	virtual void onMenuMapSize(const wxCommandEvent& event);

	virtual void Notify();

    private:
	wxBitmap*  m_bitmap;
	wxMenu*    m_menu;
	wxMenu*    m_menuSize;
	int*       m_map;
	int        m_maxHeight;
	int        m_minHeight;
	CPoint     m_point;
	int        m_mapSize;
	double     m_ulLat;
	double     m_ulLon;
	double     m_heightDeg;
	double     m_widthDeg;
	int        m_orthAngle;
	int        m_mapType;
	double     m_xhFactor;
	CPalette*  m_palette;
	bool       m_flash;
	int        m_homeX;
	int        m_homeY;

	DECLARE_EVENT_TABLE()

	void createMapData();
	void drawMap();
	void drawScale();
	void drawInfo();

	double xToLongitude(int x) const;
	double yToLatitude(int y) const;
};

#endif
