/*
 *   Copyright (C) 2003,2004 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	Coverage_H
#define	Coverage_H

#include <wx/wx.h>

#include "Defs.h"
#include "Location.h"
#include "Path.h"
#include "ITM.h"

class CCoverage : public wxPanel {

    public:
	CCoverage(int* map, int resolution, double ulLat, double ulLon, double brLat, double brLon);
	virtual ~CCoverage();

	virtual void setITM(int frequency, int polarisation, int climate, int ground, int confidence);
	virtual void setRFParams(int txPower, int txAntGain, int rxPower, int rxAntGain);

	virtual void calculate(int* coverage, const CLocation& location, int startHeight, int endHeight);

	virtual void getLOS(int* coverage, CITM& itm, double* elev, const CPath& path, int startHeight, int endHeight);

    private:
	int*       m_map;
	int        m_resolution;
	double     m_ulLat;
	double     m_ulLon;
	double     m_brLat;
	double     m_brLon;
	double     m_stepLat;
	double     m_stepLon;
	int        m_frequency;
	int        m_polarisation;
	int        m_climate;
	int        m_ground;
	int        m_confidence;
	double     m_maxPathLoss;

	double yToLatitude(int y) const;
	double xToLongitude(int x) const;

	int latitudeToY(double latitude) const;
	int longitudeToX(double longitude) const;

	int getAveHeight() const;
};

#endif
