/*
 *   Copyright (C) 2003,2004 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	CoverageDialog_H
#define	CoverageDialog_H

#include <wx/wx.h>
#include <wx/spinctrl.h>

class CCoverageDialog : public wxDialog {

    public:
	CCoverageDialog(wxWindow* parent, int height, int frequency, int polarisation, int climate, int ground, int confidence, int txPower, int txAntGain, int rxPower, int rxAntGain, int id = -1);
	virtual ~CCoverageDialog();

	virtual void onOK(const wxCommandEvent& event);
	virtual void onCancel(const wxCommandEvent& event);

	virtual int getHeight() const;
	virtual int getTXPower() const;
	virtual int getTXAntGain() const;
	virtual int getRXPower() const;
	virtual int getRXAntGain() const;
	virtual int getFrequency() const;
	virtual int getPolarisation() const;
	virtual int getClimate() const;
	virtual int getGround() const;
	virtual int getConfidence() const;

    private:
	wxTextCtrl* m_height;
	wxTextCtrl* m_txPower;
	wxTextCtrl* m_txAntGain;
	wxTextCtrl* m_rxPower;
	wxTextCtrl* m_rxAntGain;
	wxTextCtrl* m_frequency;
	wxChoice*   m_polarisation;
	wxChoice*   m_climate;
	wxChoice*   m_ground;
	wxSpinCtrl* m_confidence;

	DECLARE_EVENT_TABLE()
};

#endif
