/*
 *   Copyright (C) 2004 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <wx/wx.h>

#include "DEM.h"
#include "Defs.h"

CDEM::CDEM()
{
}

CDEM::~CDEM()
{
}

int CDEM::interpolate(int h1, int h2, int h3, int h4, double dx, double dy) const
{
	wxASSERT(dx >= 0.0 && dx <= 1.0);
	wxASSERT(dy >= 0.0 && dy <= 1.0);

	if (h1 == VOID_DATA && h2 == VOID_DATA &&
	    h3 == VOID_DATA && h4 == VOID_DATA)
		return VOID_DATA;

	if (h1 == VOID_DATA && dx < 0.5 && dy < 0.5)
		return VOID_DATA;

	if (h2 == VOID_DATA && dx < 0.5 && dy >= 0.5)
		return VOID_DATA;

	if (h3 == VOID_DATA && dx >= 0.5 && dy >= 0.5)
		return VOID_DATA;

	if (h4 == VOID_DATA && dx >= 0.5 && dy < 0.5)
		return VOID_DATA;

	if (h1 == VOID_DATA) h1 = 0;
	if (h2 == VOID_DATA) h2 = 0;
	if (h3 == VOID_DATA) h3 = 0;
	if (h4 == VOID_DATA) h4 = 0;

	int h12 = h1 + int(double(h2 - h1) * dy);
	int h43 = h4 + int(double(h3 - h4) * dy);

	return h12 + int(double(h43 - h12) * dx);
}
