/*
 *   Copyright (C) 2002-2004 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	Defs_H
#define	Defs_H

#include <cmath>
#include <complex>

using namespace std;

typedef unsigned char uchar;

enum EFormat {
	FORMAT_LATLON,
	FORMAT_LOCATOR,
	FORMAT_NGR,
	FORMAT_UTM
};

enum EDTEM {
	DTEM_SRTM,
	DTEM_GLOBE_V1,
	DTEM_GTOPO30,
	DTEM_SRTM_GLOBE_V1,
	DTEM_SRTM_GTOPO30,
	DTEM_GLOBE_V2,
	DTEM_SRTM_GLOBE_V2
};

enum EType {
	TYPE_PSEUDO_3D_1,
	TYPE_PSEUDO_3D_2,
	TYPE_ELEVATION
};

const wxString PROGRAM_TITLE = wxT("UKW Tools 0.3.5");
const wxString RELEASE_DATE  = wxT("25 July 2004");

const double R = 6378.16;

const int VOID_DATA = -32768;

const int MAX_POINT_COUNT    = 10;
const int MAX_COVERAGE_COUNT = 2;

const int GRAPH_WIDTH  = 750;
const int GRAPH_HEIGHT = 550;

const int TERRAIN_WIDTH  = 750;
const int TERRAIN_HEIGHT = 400;

const int INFO_WIDTH    = 160;
const int INFO_HEIGHT   = GRAPH_HEIGHT;

const int WINDOW_WIDTH  = GRAPH_WIDTH + INFO_WIDTH;
const int WINDOW_HEIGHT = GRAPH_HEIGHT;

const int BORDER_SIZE  = 5;

enum {
	Menu_Item_1 = 2000,
	Menu_Item_2,
	Menu_Item_3,
	Menu_Item_4,
	Menu_Item_5,
	Menu_Item_6,
	Menu_Item_7,
	Menu_Item_8,
	Menu_Item_9,
	Menu_Item_10,
	Menu_Item_11,
	Menu_Item_12,
	Menu_Item_13,
	Menu_Item_14,
	Menu_Item_15,
	Menu_Item_16,
	Menu_Item_17,
	Menu_Item_18
};

inline double RAD(double angle)
{
	return (angle / 180.0) * M_PI;
}

inline double DEG(double angle)
{
	return (angle / M_PI) * 180.0;
}

#if defined(NEED_MINMAX)

inline int max(int val1, int val2)
{
	return (val1 > val2) ? val1 : val2;
}

inline double max(double val1, double val2)
{
	return (val1 > val2) ? val1 : val2;
}

inline int min(int val1, int val2)
{
	return (val1 < val2) ? val1 : val2;
}

inline double min(double val1, double val2)
{
	return (val1 < val2) ? val1 : val2;
}

#endif

#endif
