/*
 *   Copyright (C) 2002,2003 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	Frame_H
#define	Frame_H

#include <wx/wx.h>

#include "DEMCache.h"
#include "Location.h"

class CFrame : public wxFrame {
    public:
	CFrame();
	virtual ~CFrame();

	virtual void onNew(const wxCommandEvent& event);
	virtual void onOpen(const wxCommandEvent& event);
	virtual void onSave(const wxCommandEvent& event);
	virtual void onSaveas(const wxCommandEvent& event);
	virtual void onQuit(const wxCommandEvent& event);
	virtual void on3DMap(const wxCommandEvent& event);
	virtual void onCoverage(const wxCommandEvent& event);
	virtual void onHorizon(const wxCommandEvent& event);
	virtual void onMap(const wxCommandEvent& event);
	virtual void onPaths(const wxCommandEvent& event);
	virtual void onAbout(const wxCommandEvent& event);

    private:
    	wxBoxSizer* m_sizer;
	wxWindow*   m_graph;

	DECLARE_EVENT_TABLE()

	void setGraph(wxWindow* graph);
};

#endif
