/*
 *   Copyright (C) 2002-2004 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	GTOPO30_H
#define	GTOPO30_H

#include <wx/wx.h>
#include <wx/ffile.h>

#include "DEM.h"

class CGTOPO30 : public CDEM {

    public:
	CGTOPO30(const wxString& path, double latitude, double longitude);
	virtual ~CGTOPO30();

	virtual int    getHeight(double latitude, double longitude);
	virtual void   setHeight(int height, double latitude, double longitude);

	virtual bool   dataExists() const;

	virtual bool   isInData(double latitude, double longitude) const;
	
	virtual double getMinLatitude() const;
	virtual double getMaxLatitude() const;
	
	virtual double getMinLongitude() const;
	virtual double getMaxLongitude() const;

    private:
	int      m_index;
	long     m_rowBytes;
	long     m_rows;
	long     m_cols;
	long     m_noData;
	double   m_ulX;
	double   m_ulY;
	double   m_dimX;
	double   m_dimY;
	wxFFile* m_file;

	int  findFile(double latitude, double longitude) const;
	bool readHeader(const wxString& fileName);
	void processHeader(const wxString& line);
	int  readHeight(int row, int col) const;
};

#endif
