/*
 *   Copyright (C) 2002,2003 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	Horizon_H
#define	Horizon_H

#include <wx/wx.h>

#include "DEMCache.h"
#include "Point.h"

class CHorizon : public wxPanel {

    public:
	CHorizon(wxWindow* parent, const CPoint& point, int distance, int startAngle, int endAngle, double minEle, double maxEle, double k);
	virtual ~CHorizon();

	virtual void onPaint(const wxPaintEvent& event);

    private:
	CPoint     m_point;
	int        m_height;
	double     m_k;
	int        m_distance;
	int        m_startAngle;
	int        m_endAngle;
	double     m_minEle;
	double     m_maxEle;
	wxBitmap*  m_bitmap;
	wxColour** m_palette;

	DECLARE_EVENT_TABLE()

	void createPalette();
	
	void drawMap();
	void drawScale();
	void drawInfo();

	int azimuthToX(double azimuth) const;
	int elevationToY(double elevation) const;
};

#endif
