/*
 *   Copyright (C) 2002,2003 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	HorizonDialog_H
#define	HorizonDialog_H

#include <wx/wx.h>

#include "Location.h"

class CHorizonDialog : public wxDialog {

    public:
	CHorizonDialog(wxWindow* parent, int distance, double minEle, double maxEle, double k, int id = -1);
	virtual ~CHorizonDialog();

	virtual void onOK(const wxCommandEvent& event);
	virtual void onCancel(const wxCommandEvent& event);

	virtual int    getDistance() const;
	virtual int    getStartAngle() const;
	virtual int    getEndAngle() const;
	virtual double getMinimumElevation() const;
	virtual double getMaximumElevation() const;
	virtual double getK() const;

    private:
	wxTextCtrl* m_startAngle;
	wxTextCtrl* m_endAngle;
	wxTextCtrl* m_minEle;
	wxTextCtrl* m_maxEle;
	wxTextCtrl* m_distance;
	wxChoice*   m_k;

	DECLARE_EVENT_TABLE()
};

#endif
