/*
 *   Copyright (C) 2002-2004 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	MapDialog_H
#define	MapDialog_H

#include <wx/wx.h>

#include "Location.h"

class CMapDialog : public wxDialog {

    public:
	CMapDialog(wxWindow* parent, EFormat format, int resolution, EType type, bool towns, bool sites, int id = -1);
	virtual ~CMapDialog();

	virtual void onOK(const wxCommandEvent& event);
	virtual void onCancel(const wxCommandEvent& event);

	virtual void onTowns(const wxCommandEvent& event);
	virtual void onSites(const wxCommandEvent& event);

	virtual CLocation* getLocation() const;
	virtual int        getResolution() const;
	virtual EType      getType() const;
	virtual bool       getTowns() const;
	virtual bool       getSites() const;

    private:
	wxTextCtrl* m_location;
	wxChoice*   m_format;
	wxChoice*   m_resolution;
	wxChoice*   m_type;
	bool        m_towns;
	bool        m_sites;

	DECLARE_EVENT_TABLE()
};

#endif
