/*
 *   Copyright (C) 2004 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "NGR.h"

const struct {
	int     number;
	wxChar* name;
	wxChar* swNGR;
	wxChar* neNGR;
} ngrMaps[] = {
	{1, wxT("Shetland, Yell and Unst"), wxT("HU290800"), wxT("HP690200")},
	{2, wxT("Shetland, Whalsay"), wxT("HU330560"), wxT("HU730960")},
	{3, wxT("Shetland, North Mainland"), wxT("HU140470"), wxT("HU540870")},
	{3, wxT("Shetland, North Mainland"), wxT("HU090610"), wxT("HU160670")},
	{4, wxT("Shetland, South Mainland"), wxT("HU200070"), wxT("HU600470")},
	{4, wxT("Shetland, South Mainland (insert)"), wxT("HU170680"), wxT("HU250760")},
	{5, wxT("Orkney, Northern Isles"), wxT("HY400200"), wxT("HY800600")},
	{5, wxT("Orkney, Northern Isles (insert)"), wxT("HY660150"), wxT("HY690180")},
	{6, wxT("Orkney, Mainland"), wxT("ND210960"), wxT("HY610360")},
	{6, wxT("Orkney, Mainland (insert)"), wxT("HX550170"), wxT("HX580190")},
	{6, wxT("Orkney, Mainland (insert)"), wxT("HX610230"), wxT("HX640250")},
	{7, wxT("Pentland Firth"), wxT("ND150700"), wxT("HY550100")},
	{8, wxT("Stornoway and North Lewis"), wxT("NB170260"), wxT("NB580670")},
	{8, wxT("Stornoway and North Lewis (insert)"), wxT("HW590280"), wxT("HW640330")},
	{8, wxT("Stornoway and North Lewis (insert)"), wxT("HW790300"), wxT("HW840350")},
	{9, wxT("Cape Wrath"), wxT("NC120400"), wxT("NC520800")},
	{10, wxT("Strathnaver"), wxT("NC520400"), wxT("NC920800")},
	{11, wxT("Thurso and Dunbeath"), wxT("NC920290"), wxT("ND320700")},
	{12, wxT("Thurso and Wick"), wxT("ND000390"), wxT("ND410800")},
	{13, wxT("West Lewis and North Harris"), wxT("NA940030"), wxT("NB350440")},
	{13, wxT("West Lewis and North Harris (insert)"), wxT("NA685445"), wxT("NA745475")},
	{13, wxT("West Lewis and North Harris (insert)"), wxT("NA865105"), wxT("NA895125")},
	{14, wxT("Tarbert and Loch Seaforth"), wxT("NG050860"), wxT("NB450260")},
	{15, wxT("Loch Assynt"), wxT("NB950000NC360400"), wxT("")},
	{15, wxT("Loch Assynt (insert)"), wxT("NB900010"), wxT("NB940060")},
	{16, wxT("Lairg and Loch Shin"), wxT("NC360000"), wxT("NC760400")},
	{17, wxT("Strath of Kildonan"), wxT("NC760000"), wxT("ND160400")},
	{18, wxT("Sound of Harris"), wxT("NF685630"), wxT("NB095040")},
	{18, wxT("Sound of Harris (insert)"), wxT("NF050960"), wxT("NA170070")},
	{18, wxT("Sound of Harris (insert)"), wxT("NF640660"), wxT("NF700720")},
	{18, wxT("Sound of Harris (insert)"), wxT("NF590800"), wxT("NF630830")},
	{19, wxT("Gairloch and Ullapool"), wxT("NG730600"), wxT("NH140005")},
	{20, wxT("Beinn Dearg"), wxT("NH140600"), wxT("NC540000")},
	{21, wxT("Dornoch Firth"), wxT("NH540600"), wxT("NC950000")},
	{22, wxT("Benbecula"), wxT("NF570230"), wxT("NF970630")},
	{22, wxT("Benbecula (insert)"), wxT("NF560630"), wxT("NF590660")},
	{22, wxT("Benbecula (extra)"), wxT("NF590630"), wxT("NF670640")},
	{23, wxT("North Skye"), wxT("NG120360"), wxT("NG530760")},
	{23, wxT("North Skye (extra)"), wxT("NG280355"), wxT("NG330360")},
	{23, wxT("North Skye (insert)"), wxT("NG350760"), wxT("NG450820")},
	{24, wxT("Raasay and Loch Torridon"), wxT("NG500300"), wxT("NG900700")},
	{25, wxT("Glen Carron"), wxT("NG900200"), wxT("NH300600")},
	{26, wxT("Inverness"), wxT("NH300200"), wxT("NH700600")},
	{27, wxT("Nairn"), wxT("NH700300"), wxT("NJ100700")},
	{28, wxT("Elgin"), wxT("NJ100330"), wxT("NJ500730")},
	{29, wxT("Banff"), wxT("NJ450300"), wxT("NJ850700")},
	{30, wxT("Fraserburgh and Peterhead"), wxT("NJ770300"), wxT("NK170700")},
	{31, wxT("Barra"), wxT("NL500830"), wxT("NF900230")},
	{32, wxT("South Skye"), wxT("NG300000"), wxT("NG700400")},
	{33, wxT("Loch Alsh and Glen Shiel"), wxT("NM700900"), wxT("NH100300")},
	{34, wxT("Fort Augustus"), wxT("NN100800"), wxT("NH500200")},
	{35, wxT("Kingussie"), wxT("NN500900"), wxT("NH900300")},
	{36, wxT("Grantown and Cairngorm"), wxT("NN850930"), wxT("NJ250330")},
	{37, wxT("Strathdon"), wxT("NO250930"), wxT("NJ650330")},
	{38, wxT("Aberdeen"), wxT("NO650900"), wxT("NK050300")},
	{39, wxT("Rhum and Eigg"), wxT("NM200700"), wxT("NG600100")},
	{39, wxT("Rhum and Eigg (insert)"), wxT("NM140950"), wxT("NM180980")},
	{40, wxT("Loch Shiel"), wxT("NM600600"), wxT("NN000000")},
	{41, wxT("Ben Nevis"), wxT("NN000500"), wxT("NN400900")},
	{42, wxT("Loch Rannoch"), wxT("NN400500"), wxT("NN800900")},
	{43, wxT("Braemar"), wxT("NN800600"), wxT("NJ200000")},
	{44, wxT("Ballater"), wxT("NO200600"), wxT("NJ600000")},
	{45, wxT("Stonehaven"), wxT("NO600600"), wxT("NK000000")},
	{46, wxT("Coll and Tiree"), wxT("NL925330"), wxT("NM330730")},
	{47, wxT("Tobermory"), wxT("NM200330"), wxT("NM600735")},
	{48, wxT("Iona and Ben More"), wxT("NM200100"), wxT("NM600500")},
	{49, wxT("Oban and East Mull"), wxT("NM600200"), wxT("NN000600")},
	{50, wxT("Glen Orchy"), wxT("NN000100"), wxT("NN400500")},
	{51, wxT("Loch Tay"), wxT("NN400200"), wxT("NN800600")},
	{52, wxT("Pitlochry and Aberfoyle"), wxT("NN700200"), wxT("N0100600")},
	{53, wxT("Blairgowrie"), wxT("NN940200"), wxT("NO340600")},
	{54, wxT("Dundee"), wxT("NO340200"), wxT("NO740600")},
	{55, wxT("Lochgilphead"), wxT("NR640800"), wxT("NN040200")},
	{56, wxT("Loch Lomond"), wxT("NS040820"), wxT("NN440220")},
	{57, wxT("Stirling and The Trossachs"), wxT("NS440820"), wxT("NO240300")},
	{58, wxT("Perth and Kinross"), wxT("NS840900"), wxT("NO240300")},
	{59, wxT("St Andrews and Kirkcaldy"), wxT("NT240900"), wxT("NO640300")},
	{59, wxT("St Andrews and Kirkcaldy (insert)"), wxT("NT630980"), wxT("NO670010")},
	{60, wxT("Islay12"), wxT("NR100400"), wxT("NR500805")},
	{61, wxT("Jura and Colonsay"), wxT("NR310620"), wxT("NM710020")},
	{62, wxT("North Kintyre"), wxT("NR600400"), wxT("NS000800")},
	{62, wxT("North Kintyre (extra)"), wxT("NS000750"), wxT("NS010790")},
	{63, wxT("Firth of Clyde"), wxT("NS000420"), wxT("NS400820")},
	{64, wxT("Glasgow"), wxT("NS400450"), wxT("NS800850")},
	{65, wxT("Falkirk and West Lothian"), wxT("NS800500"), wxT("NT200900")},
	{66, wxT("Edinburgh"), wxT("NT160500"), wxT("NT560900")},
	{67, wxT("Duns and Dunbar"), wxT("NT560500"), wxT("NT960900")},
	{68, wxT("South Kintyre"), wxT("NR570000"), wxT("NR970400")},
	{69, wxT("Isle of Arran"), wxT("NR750130"), wxT("NS150530")},
	{69, wxT("Isle of Arran (extra)"), wxT("NS150500"), wxT("NS160530")},
	{70, wxT("Ayr and Kilmarnock"), wxT("NS150050"), wxT("NS550450")},
	{71, wxT("Lanark and Upper Nithsdale"), wxT("NS550050"), wxT("NS950450")},
	{72, wxT("Upper Clyde Valley"), wxT("NS800200"), wxT("NT200600")},
	{73, wxT("Galashiels and Ettrick Forest"), wxT("NT200200"), wxT("NT600600")},
	{74, wxT("Kelso"), wxT("NT570200"), wxT("NT970600")},
	{75, wxT("Berwick-upon-Tweed"), wxT("NT900200"), wxT("NU300600")},
	{76, wxT("Girvan"), wxT("NW950700"), wxT("NS350100")},
	{77, wxT("Galloway and Glen Trool"), wxT("NX350700"), wxT("NS750100")},
	{78, wxT("Nithsdale and Lowther Hills"), wxT("NX750800"), wxT("NT150200")},
	{79, wxT("Hawick and Eskdale"), wxT("NY150800"), wxT("NT550200")},
	{80, wxT("Cheviot Hills"), wxT("NY550800"), wxT("NT950200")},
	{81, wxT("Alnwick and Rothbury"), wxT("NY950800"), wxT("NU350200")},
	{82, wxT("Stranraer and Glen Luce"), wxT("NW950300"), wxT("NX350700")},
	{82, wxT("Stranraer and Glen Luce (insert)"), wxT("NW960700"), wxT("NX040750")},
	{83, wxT("Kirkcudbright"), wxT("NX350300"), wxT("NX750700")},
	{84, wxT("Dumfries"), wxT("NX650400"), wxT("NY050800")},
	{85, wxT("Carlisle and Solway Firth"), wxT("NY050400"), wxT("NY450800")},
	{86, wxT("Haltwhistle and Bewcastle"), wxT("NY450400"), wxT("NY850800")},
	{87, wxT("Hexham and Haltwhistle"), wxT("NY670400"), wxT("NZ070800")},
	{88, wxT("Tyneside"), wxT("NZ070400"), wxT("NZ470800")},
	{89, wxT("West Cumbria"), wxT("NX900000"), wxT("NY300400")},
	{90, wxT("Penrith and Keswick"), wxT("NY170000"), wxT("NY570400")},
	{91, wxT("Appleby"), wxT("NY570000"), wxT("NY970400")},
	{92, wxT("Barnard Castle and Richmond"), wxT("NY800000"), wxT("ZN200400")},
	{93, wxT("Cleveland and Darlington"), wxT("NZ200000"), wxT("NZ600400")},
	{94, wxT("Whitby"), wxT("SE600850"), wxT("OV000250")},
	{95, wxT("Isle of Man"), wxT("SC130640"), wxT("NX530055")},
	{96, wxT("Barrow-in-Furness"), wxT("SD030600"), wxT("NY430000")},
	{97, wxT("Kendal and Morecambe"), wxT("SD260600"), wxT("NY660000")},
	{98, wxT("Wensleydale and Wharfdale"), wxT("SD660600"), wxT("NZ060000")},
	{99, wxT("Northallerton and Ripon"), wxT("SE060600"), wxT("NZ460000")},
	{100, wxT("Malton and Pickering"), wxT("SE460600"), wxT("NY860000")},
	{101, wxT("Scarborough"), wxT("SE860600"), wxT("OV260000")},
	{102, wxT("Preston and Blackpool"), wxT("SD260200"), wxT("SD660600")},
	{103, wxT("Blackburn and Burnley"), wxT("SD600200"), wxT("SE000600")},
	{104, wxT("Leeds and Bradford"), wxT("SE000200"), wxT("SE400600")},
	{105, wxT("York"), wxT("SE400200"), wxT("SE800600")},
	{106, wxT("Market Weighton"), wxT("SE630200"), wxT("TA030600")},
	{107, wxT("Kingston upon Hull"), wxT("TA000200"), wxT("TA400600")},
	{108, wxT("Liverpool"), wxT("SJ200800"), wxT("SD600200")},
	{108, wxT("Liverpool (insert)"), wxT("SJ170850"), wxT("SJ210920")},
	{109, wxT("Manchester"), wxT("SJ600800"), wxT("SD000200")},
	{110, wxT("Sheffield and Huddersfield"), wxT("SK000800"), wxT("SE400200")},
	{111, wxT("Sheffield and Doncaster"), wxT("SK300800"), wxT("SE700200")},
	{112, wxT("Scunthorpe"), wxT("SK700850"), wxT("TA100250")},
	{113, wxT("Grimsby and Cleethorpes"), wxT("TF100860"), wxT("TA500260")},
	{114, wxT("Anglesey"), wxT("SH200600"), wxT("SC600000")},
	{114, wxT("Anglesey (insert)"), wxT("SH600760"), wxT("SH660830")},
	{115, wxT("Caernarvon and Bngor"), wxT("SH400450"), wxT("SH800850")},
	{116, wxT("Denbigh and Colwyn Bay"), wxT("SH800450"), wxT("SJ200850")},
	{117, wxT("Chester"), wxT("SJ200400"), wxT("SJ600800")},
	{118, wxT("The Potteries"), wxT("SJ600400"), wxT("SK000800")},
	{119, wxT("Buxton, Matlock and Dove Dale"), wxT("SK000400"), wxT("SK400800")},
	{120, wxT("Mansfield and The Dukeries"), wxT("SK400500"), wxT("SK800900")},
	{121, wxT("Lincoln"), wxT("SK780500"), wxT("TF180900")},
	{122, wxT("Skegness"), wxT("TF180500"), wxT("TF580900")},
	{123, wxT("Lleyn Peninsular"), wxT("SH100200"), wxT("SH500600")},
	{124, wxT("Dolgellau"), wxT("SH500050"), wxT("SH900450")},
	{125, wxT("Bala and Lake Vyrnwy"), wxT("SH800050"), wxT("SJ200450")},
	{126, wxT("Shrewsbury"), wxT("SJ200000"), wxT("SJ600400")},
	{127, wxT("Stafford and Telford"), wxT("SJ600000"), wxT("SK000400")},
	{128, wxT("Derby and Burton upon Trent"), wxT("SK000080"), wxT("SK400480")},
	{129, wxT("Nottingham and Loughborough"), wxT("SK400100"), wxT("SK800500")},
	{130, wxT("Grantham"), wxT("SK800100"), wxT("TF200500")},
	{131, wxT("Boston and Spalding"), wxT("TF200100"), wxT("TF600500")},
	{132, wxT("North West Norfolk"), wxT("TF600100"), wxT("TG000500")},
	{133, wxT("North East Norfolk"), wxT("TG000100"), wxT("TG400500")},
	{134, wxT("Norwich and The Broads"), wxT("TM170900"), wxT("TG570300")},
	{136, wxT("Newton and Llandiloes"), wxT("SN800650"), wxT("SJ200050")},
	{137, wxT("Ludlow and Wenlock Edge"), wxT("SO200600"), wxT("SJ600000")},
	{138, wxT("Kidderminster and Wyre Forest"), wxT("SO450600"), wxT("SJ850000")},
	{139, wxT("Birmingham"), wxT("SO850680"), wxT("SK250080")},
	{140, wxT("Leicester and Coventry"), wxT("SP250700"), wxT("SK650100")},
	{141, wxT("Kettering and Corby"), wxT("SP650700"), wxT("TF050100")},
	{142, wxT("Peterborough"), wxT("TL050740"), wxT("TF450140")},
	{143, wxT("Ely and Wisbech"), wxT("TL370740"), wxT("TF770140")},
	{144, wxT("Thetford and Breckland"), wxT("TL770700"), wxT("TG170100")},
	{145, wxT("Cardigan"), wxT("SN000200"), wxT("SN400610")},
	{146, wxT("Lampeter and Llandovery"), wxT("SN400250"), wxT("SN800650")},
	{147, wxT("Elan Valley and Builth Wells"), wxT("SN700400"), wxT("SO100800")},
	{148, wxT("Presteigne and Hay-on-Wye"), wxT("SO100400"), wxT("SO500800")},
	{149, wxT("Hereford and Leominster"), wxT("SO330280"), wxT("SO730680")},
	{150, wxT("Worcester and The Malverns"), wxT("SO730280"), wxT("SP130680")},
	{151, wxT("Stratford-upon-Avon"), wxT("SP130300"), wxT("SP530700")},
	{152, wxT("Northampton and Milton Keynes"), wxT("SP530300"), wxT("SP930700")},
	{153, wxT("Bedford and Huntingdon"), wxT("SP930340"), wxT("TL330740")},
	{154, wxT("Cambridge and Newmarket"), wxT("TL330340"), wxT("TL730740")},
	{155, wxT("Bury St Edmunds and Sudbury"), wxT("TL730340"), wxT("TM130740")},
	{156, wxT("Saxmundham and Aldeburgh"), wxT("TM130500"), wxT("TM540900")},
	{157, wxT("St Davids and Haverfordwest"), wxT("SM650010"), wxT("SN050410")},
	{159, wxT("Tenby"), wxT("SS290850"), wxT("SN690250")},
	{160, wxT("Swansea and The Gower"), wxT("SN690050"), wxT("SO090450")},
	{161, wxT("Abergavenny and The Black Mountains"), wxT("SO090050"), wxT("SO490450")},
	{162, wxT("Gloucester and The Forest of Dean"), wxT("ST490880"), wxT("SO890280")},
	{163, wxT("Cheltenham and Cirencester"), wxT("ST890900"), wxT("SP290300")},
	{164, wxT("Oxford"), wxT("SU290900"), wxT("SP690300")},
	{165, wxT("Aylesbury and Leighton Buzzard"), wxT("SU600950"), wxT("TL000350")},
	{166, wxT("Luton and Hertford"), wxT("TQ000940"), wxT("TL400340")},
	{167, wxT("Chelmsford and Harlow"), wxT("TQ400940"), wxT("TL800340")},
	{168, wxT("Colchester and The Blackwater"), wxT("TQ800940"), wxT("TM200340")},
	{169, wxT("Ipswich and The Naze"), wxT("TM070100"), wxT("TM470500")},
	{170, wxT("Vale of Glamorgan and Rhondda"), wxT("SS690650"), wxT("SO090050")},
	{171, wxT("Cardiff and Newport"), wxT("ST090650"), wxT("SO490050")},
	{172, wxT("Bristol and Bath"), wxT("ST400550"), wxT("ST800950")},
	{173, wxT("Swindon and Devizes"), wxT("ST800550"), wxT("SU200950")},
	{174, wxT("Newbury and Wantage"), wxT("SU200550"), wxT("SU600950")},
	{175, wxT("Reading and Windsor"), wxT("TQ600550"), wxT("TL000950")},
	{176, wxT("West London"), wxT("SU950600"), wxT("TL150000")},
	{177, wxT("East London"), wxT("TQ300600"), wxT("TL700000")},
	{178, wxT("The Thames Estuary"), wxT("TQ650550"), wxT("TM050950")},
	{179, wxT("Canterbury and East Kent"), wxT("TR030330"), wxT("TR430730")},
	{180, wxT("Barnstaple and Ilfracombe"), wxT("SS400120"), wxT("SS800520")},
	{181, wxT("Minehead and Brendon Hills"), wxT("SS800120"), wxT("ST200520")},
	{182, wxT("Weston-super-Mare and Bridgwater"), wxT("ST200300"), wxT("ST600700")},
	{183, wxT("Yeovil and Frome"), wxT("ST490150"), wxT("ST890550")},
	{184, wxT("Salisbury and The Plain"), wxT("ST890150"), wxT("SU290550")},
	{185, wxT("Winchester and Basingstoke"), wxT("SU290160"), wxT("SU690560")},
	{186, wxT("Aldershot and Guildford"), wxT("SU650250"), wxT("TQ050650")},
	{187, wxT("Dorking, Reigate and Crawley"), wxT("TQ050250"), wxT("TQ450650")},
	{189, wxT("Ashford and Romney Marsh"), wxT("TQ850250"), wxT("TR250550")},
	{190, wxT("Bude and Clovelly"), wxT("SX070870"), wxT("SS470270")},
	{191, wxT("Okehanpton and North Dartmoor"), wxT("SX470720"), wxT("SS870120")},
	{192, wxT("Exeter and Sidmouth"), wxT("SX870720"), wxT("ST270120")},
	{193, wxT("Taunton and Lyme Regis"), wxT("SY100900"), wxT("ST500300")},
	{194, wxT("Dorchester and Weymouth"), wxT("SY490750"), wxT("ST890150")},
	{194, wxT("Dorchester and Weymouth (insert)"), wxT("SY650680"), wxT("SY710782")},
	{195, wxT("Bournemouth and Purbeck"), wxT("SY890750"), wxT("SU290150")},
	{196, wxT("Solent and the Isle of Wight"), wxT("SZ290750"), wxT("SU690160")},
	{197, wxT("Chichester and The Downs"), wxT("SZ690900"), wxT("TQ090300")},
	{198, wxT("Brighton and The Downs"), wxT("TV090900"), wxT("TQ490300")},
	{199, wxT("Eastbourne and Hastings"), wxT("TV490900"), wxT("TQ890300")},
	{200, wxT("Newquay and Bodmin"), wxT("SW750500"), wxT("SX150900")},
	{201, wxT("Plymouth and Launceston"), wxT("SX150470"), wxT("SX550870")},
	{201, wxT("Plymouth and Launceston (extra)"), wxT("SX130500"), wxT("SX150525")},
	{201, wxT("Plymouth and Launceston (extra)"), wxT("SX520455"), wxT("SX550470")},
	{201, wxT("Plymouth and Launceston (insert)"), wxT("SX380320"), wxT("SX400340")},
	{202, wxT("Torbay and South Dartmoor"), wxT("SX550320"), wxT("SX950720")},
	{203, wxT("Land's End and The Lizard"), wxT("SW315105"), wxT("SW720510")},
	{203, wxT("Land's End and The Lizard (insert)"), wxT("SW260110"), wxT("SW280130")},
	{203, wxT("Land's End and The Lizard (insert)"), wxT("SW800050"), wxT("SW960185")},
	{203, wxT("Land's End and The Lizard (insert)"), wxT("SW690500"), wxT("SW760550")},
	{204, wxT("Truro and Falmouth"), wxT("SW720140"), wxT("SX120540")},
	{204, wxT("Truro and Falmouth (extra)"), wxT("SX120480"), wxT("SX135525")},
	{204, wxT("Truro and Falmouth (extra)"), wxT("SW740540"), wxT("SW770550")}
};

const int nMaps = sizeof(ngrMaps) / sizeof(ngrMaps[0]);

CNGR::CNGR()
{
}

CNGR::~CNGR()
{
}

wxString CNGR::findMap(int sheetNo) const
{
	wxASSERT(sheetNo >= 0 && sheetNo < 205);

	for (int i = 0; i < nMaps; i++) {
		if (ngrMaps[i].number == sheetNo)
			return ngrMaps[i].name;
	}

	return wxEmptyString;
}

int* CNGR::findSheets(const wxString& ngr) const
{
	int* list = new int[10];

	for (int i = 0; i < 10; i++)
		list[i] = 0;

	int e, n;
	bool ret = getCoOrds(ngr, e, n);

	if (!ret)
		return list;

	int j = 0;
	for (int i = 0; i < nMaps; i++) {
		int swE, swN, neE, neN;
		getCoOrds(ngrMaps[i].swNGR, swE, swN);
		getCoOrds(ngrMaps[i].neNGR, neE, neN);

		if (n >= swN && n <= neN &&
		    e >= swE && e <= neE) {
			list[j] = ngrMaps[i].number;
			j++;
		}
	}

	return list;
}

bool CNGR::getCoOrds(const wxString& ngr, int& east, int& north) const
{
	if (ngr.Length() != 2 && ngr.Length() != 4 && ngr.Length() != 6 &&
	    ngr.Length() != 8 && ngr.Length() != 10)
		return false;

	wxString letters = ngr.Left(2);
	wxString numbers = ngr.Mid(2);

	wxChar first = letters.GetChar(0);
	if (first != wxT('S') && first != wxT('T') && first != wxT('N') &&
	    first != wxT('H') && first != wxT('O'))
		return false;

	wxChar second = letters.GetChar(1);
	if (second < wxT('A') || second > wxT('Z') || second == wxT('I'))
		return false;

	for (int i = 0; i < int(numbers.Length()); i++) {
		wxChar c = numbers.GetChar(i);

		if (c < wxT('0') || c > wxT('9'))
			return false;
	}

	int s500 = letters.GetChar(0) - wxT('A');
	if (s500 > 8) s500--;

	north = 500000 * (3 - s500 / 5);
	east  = 500000 * (s500 % 5 - 2);

	int s100 = letters.GetChar(1) - wxT('A');
	if (s100 > 8) s100--;

	north += 100000 * (4 - s100 / 5);
	east  += 100000 * (s100 % 5);

	if (numbers.Length() > 0) {
		int scale = 0;

		switch (numbers.Length()) {
			case 2:
				scale = 10000;
				break;
			case 4:
				scale = 1000;
				break;
			case 6:
				scale = 100;
				break;
			case 8:
				scale = 10;
				break;
		}

		long n, e;
		numbers.Right(numbers.Length() / 2).ToLong(&n);
		numbers.Left(numbers.Length() / 2).ToLong(&e);

		east  += e * scale;
		north += n * scale;
	}

	return true;
}
