/*
 *   Copyright (C) 2002,2003 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	Palette_H
#define	Palette_H

#include <wx/wx.h>

class CPalette {

    public:
	static CPalette* getInstance();
	virtual ~CPalette();

	virtual wxColour& getColour(int n) const;

	virtual void setPaletteNo(int n);
	virtual void nextPalette();
	virtual void prevPalette();

	virtual int getPaletteNo() const;
	virtual int getColourCount() const;
	virtual int getPaletteCount() const;

    protected:
	CPalette();

    private:
	static CPalette* s_instance;

	wxColour** m_colours;
	int        m_palette;

	void fillinPalette();
};

#endif
