/*
 *   Copyright (C) 2002-2004 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	Path_H
#define	Path_H

#include "Location.h"

class CPath {

    public:
	CPath(const CLocation& location);
	CPath(double lat, double lon);
	virtual ~CPath();

	virtual void setDest(const CLocation& location);
	virtual void setDest(double lat, double lon);
	virtual void setDestAzDist(double az, double dist);

	virtual CLocation getStart() const;
	virtual CLocation getEnd() const;

	virtual double getDistance() const;
	virtual double getBearing() const;

	virtual void      getPath(double distance, double& latitude, double& longitude) const;
	virtual CLocation getPath(double distance) const;

    private:
	double m_slat;
	double m_slon;
	double m_dlat;
	double m_dlon;
	double m_azimuth;
	double m_distance;

	void   fillinData();
	double FORTRAN_SIGN(double a, double b) const;
};

#endif
