/*
 *   Copyright (C) 2003,2004 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	PathPreferences_H
#define	PathPreferences_H

#include <wx/wx.h>

#include "Defs.h"

class CPathPreferences : public wxDialog {

    public:
	CPathPreferences(wxWindow* parent, const wxString& srtmPath, const wxString& globePath, const wxString& gtopo30Path, int dtem, const wxString& dataPath, const wxString& mapQTHPath, int id = -1);
	virtual ~CPathPreferences();

	virtual void onBrowse(const wxCommandEvent& event);

	virtual void onOK(const wxCommandEvent& event);
	virtual void onCancel(const wxCommandEvent& event);

	virtual wxString getSRTMPath() const;
	virtual wxString getGTOPO30Path() const;
	virtual wxString getGlobePath() const;
	virtual EDTEM    getDTEM() const;
	virtual wxString getDataPath() const;
	virtual wxString getMapQTHPath() const;

    private:
	wxTextCtrl* m_srtmPath;
	wxTextCtrl* m_globePath;
	wxTextCtrl* m_gtopo30Path;
	wxChoice*   m_dtem;
	wxTextCtrl* m_dataPath;
	wxTextCtrl* m_mapQTHPath;

	DECLARE_EVENT_TABLE()
};

#endif
