/*
 *   Copyright (C) 2003,2004 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "Point.h"

CPoint::CPoint(const wxString& name, const wxString& fileName, const CLocation& location, int height, int asl) :
m_name(name),
m_fileName(fileName),
m_location(location),
m_height(height),
m_asl(asl),
m_coverage(true)
{
	wxASSERT(height >= 0);
}

CPoint::CPoint(const wxString& name, const CLocation& location, int height, int asl) :
m_name(name),
m_fileName(wxEmptyString),
m_location(location),
m_height(height),
m_asl(asl),
m_coverage(true)
{
	wxASSERT(height >= 0);
}

CPoint::CPoint(const CPoint& point) :
m_name(point.m_name),
m_location(point.m_location),
m_height(point.m_height),
m_asl(point.m_asl),
m_coverage(point.m_coverage)
{
}

CPoint::~CPoint()
{
}

void CPoint::setFileName(const wxString& fileName)
{
	m_fileName = fileName;
}

void CPoint::setCoverage(bool coverage)
{
	m_coverage = coverage;
}

wxString CPoint::getName() const
{
	return m_name;
}

wxString CPoint::getFileName() const
{
	return m_fileName;
}

CLocation CPoint::getLocation() const
{
	return m_location;
}

int CPoint::getHeight() const
{
	return m_height;
}

int CPoint::getASL() const
{
	return m_asl;
}

bool CPoint::getCoverage() const
{
	return m_coverage;
}
