/*
 *   Copyright (C) 2003,2004 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	Point_H
#define	Point_H

#include "Location.h"

#include <wx/wx.h>

class CPoint {
    public:
	CPoint(const wxString& name, const wxString& fileName, const CLocation& location, int height, int asl);
	CPoint(const wxString& name, const CLocation& location, int height, int asl);
	CPoint(const CPoint& point);
	virtual ~CPoint();

	virtual void      setFileName(const wxString& fileName);
	virtual void      setCoverage(bool coverage);

	virtual wxString  getName() const;
	virtual wxString  getFileName() const;
	virtual CLocation getLocation() const;
	virtual int       getHeight() const;
	virtual int       getASL() const;
	virtual bool      getCoverage() const;

    private:
	wxString  m_name;
	wxString  m_fileName;
	CLocation m_location;
	int       m_height;
	int       m_asl;
	bool      m_coverage;
};

#endif
