/*
 *   Copyright (C) 2003,2004 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	PointDialog_H
#define	PointDialog_H

#include <wx/wx.h>

#include "Location.h"

class CPointDialog : public wxDialog {

    public:
	CPointDialog(wxWindow* parent, const CLocation& location, EFormat format, int height, int asl, int id = -1);
	virtual ~CPointDialog();

	virtual void onOK(const wxCommandEvent& event);
	virtual void onCancel(const wxCommandEvent& event);

	virtual wxString   getName() const;
	virtual CLocation* getLocation() const;
	virtual int        getHeight() const;
	virtual int        getASL() const;

    private:
	wxTextCtrl* m_name;
	wxTextCtrl* m_location;
	wxChoice*   m_format;
	wxTextCtrl* m_height;
	wxTextCtrl* m_asl;

	DECLARE_EVENT_TABLE()
};

#endif
