/*
 *   Copyright (C) 2003,2004 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	SRTM_H
#define	SRTM_H

#include <wx/wx.h>

#include "DEM.h"

class CSRTM : public CDEM {

    public:
	CSRTM(const wxString& path, double latitude, double longitude);
	virtual ~CSRTM();

	virtual int    getHeight(double latitude, double longitude);
	virtual void   setHeight(int height, double latitude, double longitude);

	virtual bool   isInData(double latitude, double longitude) const;

	virtual bool   dataExists() const;
	
	virtual double getMinLatitude() const;
	virtual double getMaxLatitude() const;
	
	virtual double getMinLongitude() const;
	virtual double getMaxLongitude() const;

    private:
	int      m_minLatitude;
	int      m_maxLatitude;
	int      m_minLongitude;
	int      m_maxLongitude;
	double   m_llX;
	double   m_llY;
	short*   m_data;
	bool*    m_checked;

	wxString findFileName(double& latitude, double& longitude);
	bool     readZipFileData(const wxString& path, const wxString& name, const wxString& ext, const wxString& file);
	bool     readRawFileData(const wxString& path, const wxString& name, const wxString& ext);
	bool     readFileData(wxInputStream& stream);
	int      readHeight(int row, int col) const;
};

#endif
