/*
 *   Copyright (C) 2003,2004 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	TownList_H
#define	TownList_H

#include "Point.h"

#include <wx/wx.h>

WX_DECLARE_LIST(CPoint, CTownData);

class CTownList {
    public:
	virtual ~CTownList();

	static CTownList* create(const wxString& path);
	static CTownList* getInstance();

	virtual CPoint* find(const wxString& name) const;

	virtual CPoint* getFirst(double lat1, double lon1, double lat2, double lon2);
	virtual CPoint* getNext();

	virtual int getCount() const;

    protected:
	CTownList(const wxString& path);

    private:
	static CTownList* m_instance;
	wxString          m_path;
	CTownData*        m_townData;
	double            m_lat1;
	double            m_lon1;
	double            m_lat2;
	double            m_lon2;
	CTownData::Node*  m_node;

	void    loadTowns();
	CPoint* getData(bool first);
};

#endif
